Bug 1286459 - (rtfilter) Review Request: rtfilter - Library implementing realtime digital filtering functions for multichannel signals
Review Request: rtfilter - Library implementing realtime digital filtering fu...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Zbigniew Jędrzejewski-Szmek
Fedora Extras Quality Assurance
:
Depends On:
Blocks: fedora-neuro 1286460
  Show dependency treegraph
 
Reported: 2015-11-29 12:48 EST by Igor Gnatenko
Modified: 2015-12-09 15:50 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-09 15:50:08 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zbyszek: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Igor Gnatenko 2015-11-29 12:48:50 EST
Spec URL: https://ignatenkobrain.fedorapeople.org/neurofedora/rtfilter.spec
SRPM URL: https://ignatenkobrain.fedorapeople.org/neurofedora/rtfilter-1.1-1.fc24.src.rpm
Description:
rtfilter provides a library written in C implementing realtime digital
filtering functions for multichannel signals (i.e. filtering multiple
signals with the same filter). It implements FIR, IIR filters and
downsampler for float and double data type (both for real and complex
valued signal). Additional functions are also provided to design few
usual filters: Butterworth, Chebyshev, windowed sinc, analytical filter...

One of the main differences from other libraries providing digital signal
processing is that the filter functions have been specifically designed and
optimized for multichannel signals (from few channels to several hundred).
If data allows it, the library automatically switch to optimized SIMD
(Single Instruction Multiple Data) code, allowing to reduce by 3~4 the time
spent in processing the data.
Fedora Account System Username: ignatenkobrain
Comment 1 Zbigniew Jędrzejewski-Szmek 2015-11-30 14:15:24 EST
- BR: libtool is needed.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
LGPLv3.

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 74 files have unknown license. Detailed
     output of licensecheck in /var/tmp/1286459-rtfilter/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
See above.

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[X]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     rtfilter-devel , rtfilter-debuginfo
OK: -devel has a versioned and arched Requires.

[-]: Package functions as described.
I didn't check since it's a library. If not, it'll come out in dependent reviews ;)

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.

Rpmlint
-------
Checking: rtfilter-1.1-1.fc24.x86_64.rpm
          rtfilter-devel-1.1-1.fc24.x86_64.rpm
          rtfilter-debuginfo-1.1-1.fc24.x86_64.rpm
          rtfilter-1.1-1.fc24.src.rpm

rtfilter.src: E: summary-too-long C Library implementing realtime digital filtering functions for multichannel signals
Please shorten!

rtfilter.x86_64: W: spelling-error Summary(en_US) realtime -> mealtime, real time, real-time
rtfilter.x86_64: W: spelling-error Summary(en_US) multichannel -> multiplicand
rtfilter.x86_64: E: summary-too-long C Library implementing realtime digital filtering functions for multichannel signals
rtfilter.x86_64: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
rtfilter.x86_64: W: spelling-error %description -l en_US multichannel -> multiplicand
rtfilter.x86_64: W: spelling-error %description -l en_US downsampler -> down sampler, down-sampler, downs ampler
rtfilter.x86_64: W: spelling-error %description -l en_US Butterworth -> Butter worth, Butter-worth, Butterscotch
rtfilter.x86_64: W: spelling-error %description -l en_US sinc -> sin, sic, inc
rtfilter.x86_64: W: spelling-error %description -l en_US analytical -> analytically, analytic, catalytic
rtfilter-devel.x86_64: W: only-non-binary-in-usr-lib
rtfilter.src: W: spelling-error Summary(en_US) realtime -> mealtime, real time, real-time
rtfilter.src: W: spelling-error Summary(en_US) multichannel -> multiplicand

rtfilter.src: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
rtfilter.src: W: spelling-error %description -l en_US multichannel -> multiplicand
rtfilter.src: W: spelling-error %description -l en_US downsampler -> down sampler, down-sampler, downs ampler
rtfilter.src: W: spelling-error %description -l en_US Butterworth -> Butter worth, Butter-worth, Butterscotch
rtfilter.src: W: spelling-error %description -l en_US sinc -> sin, sic, inc
rtfilter.src: W: spelling-error %description -l en_US analytical -> analytically, analytic, catalytic
4 packages and 0 specfiles checked; 2 errors, 17 warnings.

OK.

Requires
--------
rtfilter (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)

rtfilter-debuginfo (rpmlib, GLIBC filtered):

rtfilter-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    librtfilter.so.1()(64bit)
    rtfilter(x86-64)

Provides
--------
rtfilter:
    librtfilter.so.1()(64bit)
    rtfilter
    rtfilter(x86-64)

rtfilter-debuginfo:
    rtfilter-debuginfo
    rtfilter-debuginfo(x86-64)

rtfilter-devel:
    pkgconfig(rtfilter)
    rtfilter-devel
    rtfilter-devel(x86-64)

Everything looks good, except for the overlong summary and missing BR. Please fix when submitting.

Package is APPROVED.
Comment 2 Igor Gnatenko 2015-11-30 14:18:53 EST
> LGPLv3.
from COPYING file is GPLv3+
sources has header with LGPLv3+.

What is right?

Will fix all stuff when submitting.
Comment 3 Zbigniew Jędrzejewski-Szmek 2015-11-30 14:27:57 EST
Oh, right. I looked at their webpage, but not at the headers.

The headers say GPLv3 (at least some of them). So in effect I think GPLv3 is the right license.

There's also src/led.license which says "public domain" for some png assets. You should add this file to %license-s.
Comment 4 Zbigniew Jędrzejewski-Szmek 2015-11-30 14:28:51 EST
Debian has a package, but it seems mistaken about the license:
http://metadata.ftp-master.debian.org/changelogs//main/r/rtfilter/rtfilter_1.1-4_copyright. That doesn't match the headers.
Comment 5 Igor Gnatenko 2015-11-30 14:29:19 EST
(In reply to Zbigniew Jędrzejewski-Szmek from comment #3)
> Oh, right. I looked at their webpage, but not at the headers.
> 
> The headers say GPLv3 (at least some of them). So in effect I think GPLv3 is
> the right license.
Are you sure that GPLv3 and not GPLv3+?
> 
> There's also src/led.license which says "public domain" for some png assets.
> You should add this file to %license-s.
Ok, will do.
Comment 6 Zbigniew Jędrzejewski-Szmek 2015-11-30 14:44:19 EST
Pfff, sorry. I was looking at the mcpanel sources.

So, the headers in src/ specify LGPLv3 (no +). Examples and tests are GPLv3 (no +). So the debian copyright file is correct, and it matches the information on the upstream webpage.

In the binary package examples and tests are not included, so the effective license is LGPLv3. I think you should add a comment clarifying that in the spec file.
Comment 7 Igor Gnatenko 2015-11-30 14:55:23 EST
(at your option) any later version

I thought that we had this which makes license with +.

I will check it.
Comment 8 Gwyn Ciesla 2015-11-30 15:42:08 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rtfilter
Comment 9 Fedora Update System 2015-11-30 17:42:12 EST
rtfilter-1.1-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-2a9dcea2c7
Comment 10 Fedora Update System 2015-12-01 17:30:41 EST
rtfilter-1.1-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update rtfilter'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-2a9dcea2c7
Comment 11 Fedora Update System 2015-12-09 15:50:05 EST
rtfilter-1.1-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.